// utils.h
// function declarations for utility functions in utils.cpp
#ifndef UTILS_H
#define UTILS_H

//=================================================================================================
double *dmatrix(int n);
double det2(double a, double b, double c, double d);
//=================================================================================================
// Integration 
double GaussLegendreQuad(double (*func)(double),double a,double b);
double DoubleGaussLegendreQuad(double (*func)(double,double),double a1,double b1,double a2,double b2);
//=================================================================================================
// Root finding (root)
double root_brent(double (*func)(double), double x1, double x2,double fa,double fb,double tol,int itmax);
//=================================================================================================
// ODE Integration (ode)
void ode_rungekutta4(double y[], double dydx[],int n, double x, double h,
		 void (*derivs)(double, double [], double []));
void ode_rungekuttaAdaptiveStep(double *y,double *dydx,int N,double *x,double htry,double eps,
		  double *yscal, double *hdid, double *hnext,
		  void (*derivs)(double, double*, double*));
//=================================================================================================
// Interpolation Routines
void interp_spline(double *,double *,int,double,double,double *);
double interp_splint(double *, double *, double *,int,double);
#endif
//=================================================================================================
